package cgl.linkanalyzer;
/*
 * <p>Title: Analyzer.java</p>
 * <p>Description: URL Analyzer Class
 * <p>authors: M Aktas & M Nacar
 */

import java.io.*;
import java.util.*;
import java.net.*;
import net.nutch.db.*;

// Analysis URLs based on country and sub domain extensions
// Parses a URL and gets country and sub domain tags to further classification
public class Analyzer {
  // private static WebDBReader webdb;

  public Analyzer() {
  }

  // Aggregates getExtension() and getContinent() methods to give combined values
  public String getDomain(String Url) throws Exception {
    if (this.getExtension(Url).equals("none") &&
        !this.getContinent(Url).equals("none")) {
      return this.getContinent(Url);
    }
    else if (!this.getExtension(Url).equals("none") &&
             this.getContinent(Url).equals("none")) {
      return this.getExtension(Url);
    }
    else if (!this.getExtension(Url).equals("none") &&
             !this.getContinent(Url).equals("none")) {
      return this.getExtension(Url) + "_" + this.getContinent(Url);
    }
    else {
      return "";
    }
  }

  // Extracts given URL's sub domain extension
  public String getExtension(String Url) throws Exception {
    URL url = new URL(Url);
    Vector vec = new Vector();

    StringTokenizer str = new StringTokenizer(url.getHost().toString(), ":/.?~");
    while (str.hasMoreTokens()) {
      vec.addElement(str.nextToken());
    }

    if (vec.contains("com")) {
      return "com";
    }
    else if (vec.contains("net")) {
      return "net";
    }
    else if (vec.contains("org")) {
      return "org";
    }
    else if (vec.contains("gov")) {
      return "gov";
    }
    else if (vec.contains("edu")) {
      return "edu";
    }
    else if (vec.contains("mil")) {
      return "mil";
    }

    return "none";
  }

  // Extracts given URL's country extension
  public String getContinent(String Url) throws Exception {
    URL url = new URL(Url);

    Vector asia = new Vector();
    Vector europe = new Vector();
    Vector america = new Vector();

    asia.add("af");
    asia.add("am");
    asia.add("az");
    asia.add("bh");
    asia.add("bd");
    asia.add("bt");
    asia.add("bn");
    asia.add("kh");
    asia.add("cn");
    asia.add("tp");
    asia.add("ge");
    asia.add("in");
    asia.add("id");
    asia.add("ir");
    asia.add("il");
    asia.add("jp");
    asia.add("jo");
    asia.add("kz");
    asia.add("kp");
    asia.add("kr");
    asia.add("kw");
    asia.add("kg");
    asia.add("la");
    asia.add("lb");
    asia.add("my");
    asia.add("mv");
    asia.add("mn");
    asia.add("mm");
    asia.add("om");
    asia.add("pk");
    asia.add("ph");
    asia.add("qa");
    asia.add("sa");
    asia.add("sg");
    asia.add("lk");
    asia.add("sy");
    asia.add("tw");
    asia.add("tj");
    asia.add("th");
    asia.add("tm");
    asia.add("ae");
    asia.add("uz");
    asia.add("vn");
    asia.add("ye");

    europe.add("al");
    europe.add("ad");
    europe.add("at");
    europe.add("by");
    europe.add("be");
    europe.add("ba");
    europe.add("bg");
    europe.add("hr");
    europe.add("cz");
    europe.add("dk");
    europe.add("ee");
    europe.add("fi");
    europe.add("fr");
    europe.add("de");
    europe.add("gr");
    europe.add("hu");
    europe.add("is");
    europe.add("ie");
    europe.add("it");
    europe.add("lv");
    europe.add("li");
    europe.add("lt");
    europe.add("lu");
    europe.add("mk");
    europe.add("mt");
    europe.add("md");
    europe.add("mc");
    europe.add("nl");
    europe.add("no");
    europe.add("pl");
    europe.add("pt");
    europe.add("ro");
    europe.add("ru");
    europe.add("sm");
    europe.add("sk");
    europe.add("si");
    europe.add("es");
    europe.add("se");
    europe.add("ch");
    europe.add("tr");
    europe.add("ua");
    europe.add("uk");
    europe.add("va");
    europe.add("yu");

    america.add("us");
    america.add("ca");
    america.add("mx");

    Vector vec = new Vector();
    StringTokenizer str = new StringTokenizer(url.getHost().toString(), ":/.?~");
    while (str.hasMoreTokens()) {
      vec.addElement(str.nextToken());
      // System.out.println("token " + vec.lastElement() );
    }

    if (asia.contains(vec.lastElement())) {
      return "asi";
    }
    else if (europe.contains(vec.lastElement())) {
      return "eur";
    }
    else if (america.contains(vec.lastElement())) {
      return "ame";
    }

    return "ame";
  }

  public String getSubDomain(String URL) {
    return "OK";
  }

  public static void main(String argv[]) throws FileNotFoundException,
      IOException, Exception {
    //  File f = new File("db");
    //  webdb = new WebDBReader(f);
    //  System.out.println("name " + f.getName());
    //  System.out.println("num " + webdb.numPages());
    //  Enumeration en = webdb.pages();
    Analyzer an = new Analyzer();
    System.out.println("hmmm...Domain= " +
                       an.getExtension("http://www.manacar.com/erer/erere/erere/rrere?eee"));
    System.out.println("hmmm...Domain= " +
                       an.getExtension("http://www.manacar.mil/erer/erere/erere/rrere?eee"));
    System.out.println("hmmm...Domain= " +
                       an.getDomain("http://www.manacar.com.tr"));
    System.out.println("hmmm...Domain= " +
                       an.getDomain("http://www.manacar.mil.cn"));
    System.out.println("hmmm...Domain= " + an.getDomain("http://www.manacar.cn"));
    System.out.println("hmmm...Domain= " +
                       an.getDomain("http://www.manacar.mil"));
  }
}
